Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
always have display_timing activated for smpi, as it is quite useful
[simgrid.git] / src / smpi / smpirun.in
index 6e5f71b..861ed11 100755 (executable)
@@ -13,10 +13,42 @@ LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
-NUMPROCS="${DEFAULT_NUMPROCS}"
 POWER="${DEFAULT_POWER}"
 
-SIMOPTS="--cfg=network/model:SMPI --cfg=TCP_gamma:4194304"
+SIMOPTS="--cfg=maxmin/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304 --cfg=smpi/display_timing:1"
+
+#usage to print the way this script should be called
+function usage () {
+cat <<EOF
+Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
+Options:
+  -keep-temps                # don't remove the generated files after execution
+  -map                       # display the machine on which each process rank is mapped
+  -np <numprocs>             # use that amount of processes from the hostfile.
+                             # By default, all processes of the hostfile are used.
+  -trace                     # activate tracing
+  -trace-comment <comment>   # put a comment on the top of the trace file
+  -trace-comment-file <file> # put file contents on the top of the trace file as comment
+  -trace-grouped             # group MPI processes by location
+  -trace-resource            # trace resource utilization
+  -trace-viva               # generate configuration for Viva's GraphView
+  -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
+  -ext <value>               # additional parameter (reserved)
+
+or (deprecated usage):
+  $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
+
+EOF
+}
+
+#check if we have at least one parameter
+if [ $# -eq 0 ]
+then
+    usage
+    exit
+fi
+
+EXTOPT=""
 
 while true; do
   case "$1" in
@@ -34,7 +66,7 @@ while true; do
     ;;
    "-platform")
        PLATFORM="$2"
-      if [ ! -f ${PLATFORM} ]; then
+      if [ ! -f "${PLATFORM}" ]; then
                echo "[$0] ** error: the file '${PLATFORM}' does not exist. Aborting."
                exit 1
       fi
@@ -42,21 +74,56 @@ while true; do
     ;;
    "-hostfile")
        HOSTFILE="$2"
-      if [ ! -f ${HOSTFILE} ]; then
+      if [ ! -f "${HOSTFILE}" ]; then
                echo "[$0] ** error: the file '${HOSTFILE}' does not exist. Aborting."
                exit 1
       fi
        shift 2
     ;;
 
+   "-ext")
+      EXTOPT="$2"
+      shift 2
+   ;;
+
    "-map")
        MAPOPT="true"
       shift 1
    ;;
 
    "-trace")
-       TRACEOPT="$2"
-         shift 2
+      TRACE_ACTIVE="true"
+      shift 1
+   ;;
+
+   "-trace-comment")
+      TRACE_COMMENT="$2"
+      shift 2
+   ;;
+
+   "-trace-comment-file")
+      TRACE_COMMENT_FILE="$2"
+      shift 2
+   ;;
+
+   "-trace-file")
+      TRACE_FILENAME="$2"
+      shift 2
+   ;;
+
+   "-trace-grouped")
+      TRACE_GROUPED="true"
+      shift 1
+   ;;
+
+   "-trace-resource")
+      TRACE_RESOURCE="true"
+      shift 1
+   ;;
+
+   "-trace-viva")
+       TRACE_VIVA="true"
+         shift 1
    ;;
 
    "-keep-temps")
@@ -65,11 +132,7 @@ while true; do
    ;;
 
    "-help" | "--help" | "-h")
-      echo "usage:"
-      echo "$0 [-quiet] [-keep-temps] [-trace <tracefile>] [-np <numprocs>] -platform <xmldesc> -hostfile <hostfile> [-map] program [program-options]"
-      echo "or (deprecated usage):"
-      echo "$0 [-quiet] [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]"
-      echo
+      usage
       exit
    ;;
 
@@ -91,8 +154,31 @@ shift
 
 ##-----------------------------------
 
+# Basic checks on the provided arguments
+if [ -z "${EXEC}" ] ; then
+    echo "You must provide a program to execute."
+    usage
+    exit 1
+fi
 
+if [ -z "${HOSTFILE}" ] ; then
+    echo "No hostfile specified."
+    usage
+    exit 1
+fi
 
+# Don't use wc -l to compute it to avoid issues with trailing \n at EOF
+hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
+
+if [ -z "${NUMPROCS}" ] ; then
+    # Use the amount of processes in the hostfile as default value for the -np parameter
+    NUMPROCS=$hostfile_procs
+fi
+
+
+if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
+    echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
+fi
 
 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
 if [ -z "${PLATFORM}" ]; then
@@ -100,8 +186,8 @@ if [ -z "${PLATFORM}" ]; then
 
        cat > ${PLATFORMTMP} <<PLATFORMHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "simgrid.dtd">
-<platform version="2">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
+<platform version="3">
 <AS id="AS0" routing="Full">
 PLATFORMHEAD
 
@@ -138,8 +224,8 @@ APPLICATIONTMP="$(mktemp tmpXXXXXX)"
 
 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "simgrid.dtd">
-<platform version="2">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
+<platform version="3">
 APPLICATIONHEAD
 
 ##---- cache hostnames of hostfile---------------
@@ -148,6 +234,17 @@ if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
       NUMHOSTS=`cat ${HOSTFILE} | wc -l`
 fi
 
+if [ "${EXTOPT}" = "smpi_replay" ]; then
+  APP_TRACES=$1;
+  if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
+     hosttraces=(`cat ${APP_TRACES} | tr \\\n " "`)
+     NUMTRACES=`cat ${APP_TRACES} | wc -l`
+  else
+     printf "File not found: %s\n", "${APP_TRACES:-\${APP_TRACES}}" >&2
+     exit 1
+  fi
+fi
+
 ##----------------------------------------------------------
 ##  generate application.xml with hostnames from hostfile:
 ##  the name of host_i (1<=i<=p, where -np p) is the line i
@@ -184,11 +281,19 @@ do
   else
        host="${hostnames[$j]}"
   fi
-  echo "  <process host=\"${host}\" function=\"smpi_simulated_main\">" >> ${APPLICATIONTMP}
+  echo "  <process host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->" >> ${APPLICATIONTMP}
   echo "    <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
-  for ARG in $*; do
-    echo "    <argument value=\"${ARG}\"/>" >> ${APPLICATIONTMP}
-  done
+  if [ "${EXTOPT}" = "smpi_replay" ]; then
+    if  [ ${NUMTRACES} -gt 1 ]; then
+      echo "    <argument value=\"${hosttraces[$j]}\"/>" >> ${APPLICATIONTMP}
+    else
+      echo "    <argument value=\"${hosttraces[0]}\"/>" >> ${APPLICATIONTMP}
+    fi
+  else 
+    for ARG in $*; do
+       echo "    <argument value=\"${ARG}\"/>" >> ${APPLICATIONTMP}
+    done
+  fi
   echo "  </process>" >> ${APPLICATIONTMP}
 done
 
@@ -198,11 +303,33 @@ APPLICATIONFOOT
 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
 
 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
-  if [ -n "${TRACEOPT}" ]; then
-    TRACEOPTIONS="--cfg=tracing/filename:${TRACEOPT} --cfg=tracing/smpi:1 --cfg=tracing/platform:1"
-  else
-    TRACEOPTIONS=""
+if [ -n "${TRACE_ACTIVE}" ]; then
+  #define trace filename
+  if [ -z "${TRACE_FILENAME}" ]; then
+    TRACE_FILENAME="smpi_simgrid.trace"
   fi
+  TRACEOPTIONS="--cfg=tracing:1 --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:1"
+
+  if [ -n "${TRACE_COMMENT}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
+  fi
+
+  if [ -n "${TRACE_COMMENT_FILE}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment_file:${TRACE_COMMENT_FILE}"
+  fi
+
+  if [ -n "${TRACE_GROUPED}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:1"
+  fi
+
+  if [ -n "${TRACE_RESOURCE}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:1 --cfg=tracing/uncategorized:1"
+  fi
+
+  if [ -n "${TRACE_VIVA}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=viva/categorized:smpi_cat.plist --cfg=viva/uncategorized:smpi_uncat.plist"
+  fi
+fi
 ##---------------------- end SMPI TRACING OPTIONS ---------------------------------
 
 export SMPI_GLOBAL_SIZE=${NUMPROCS}
@@ -210,6 +337,7 @@ if [ -n "${KEEP}" ] ; then
   echo ${EXEC} ${SIMOPTS} ${TRACEOPTIONS} ${PLATFORMTMP} ${APPLICATIONTMP}
 fi
 ${EXEC} ${SIMOPTS} ${TRACEOPTIONS} ${PLATFORMTMP} ${APPLICATIONTMP}
+status=$?
 
 if [ -z "${KEEP}" ] ; then
    if [ -z "${PLATFORM}" ]; then
@@ -217,3 +345,5 @@ if [ -z "${KEEP}" ] ; then
    fi
    rm ${APPLICATIONTMP}
 fi
+
+exit $status